# Acknowledgments

CodeMap relies on these excellent open-source libraries and models:

## Core Dependencies
* [LiteLLM](https://github.com/BerriAI/litellm) (>=1.67.0) - Unified interface for LLM providers
* [NumPy](https://numpy.org/) (>=2.2.5) - Numerical computing for vector operations
* [Pygments](https://pygments.org/) (>=2.19.1) - Syntax highlighting for code snippets
* [Python-dotenv](https://github.com/theskumar/python-dotenv) (>=1.1.0) - Environment variable management
* [PyYAML](https://pyyaml.org/) (>=6.0.2) - YAML parsing and configuration management
* [Questionary](https://github.com/tmbo/questionary) (>=2.1.0) - Interactive user prompts
* [Requests](https://requests.readthedocs.io/) (>=2.32.3) - HTTP library for API interactions
* [Rich](https://rich.readthedocs.io/) (>=14.0.0) - Beautiful terminal formatting and output
* [Typer](https://typer.tiangolo.com/) (>=0.15.2) - Modern CLI framework for Python
* [Typing Extensions](https://github.com/python/typing_extensions) (>=4.13.2) - Backported typing features
* [Sentence-Transformers](https://www.sbert.net/) (>=4.1.0) - Text embeddings for semantic code analysis

## Development Tools
* [isort](https://pycqa.github.io/isort/) (>=6.0.1) - Import sorting
* [pylint](https://pylint.readthedocs.io/) (>=3.3.6) - Code analysis
* [pyright](https://github.com/microsoft/pyright) (>=1.1.399) - Static type checking
* [pytest](https://docs.pytest.org/) (>=8.3.5) - Testing framework
* [pytest-cov](https://pytest-cov.readthedocs.io/) (>=6.1.1) - Test coverage reporting
* [ruff](https://github.com/astral-sh/ruff) (>=0.11.6) - Fast Python linter

## Models
* **Code Embeddings**: [Qodo/Qodo-Embed-1-1.5B](https://huggingface.co/Qodo/Qodo-Embed-1-1.5B) - State-of-the-art embedding model optimized for code retrieval tasks.
* **LLM Support**: Compatible with various providers through LiteLLM including:
  - OpenAI models
  - Anthropic Claude models
  - Groq models
  - Mistral models
  - Cohere models
  - Together AI models
  - OpenRouter providers

## Special Thanks
* [Cursor](https://www.cursor.com/)
* [OpenHands](https://github.com/All-Hands-AI/OpenHands)
* [GitHub Actions](https://github.com/features/actions)
* [Img Shields](https://shields.io)
* [Codecov](https://about.codecov.io/) 