# CodeMap: AI-Powered Developer Toolkit

Welcome to the CodeMap documentation!

CodeMap is an AI-powered developer toolkit designed to enhance your development workflow. It offers features like token-optimized documentation generation, semantic code analysis, and streamlined Git operations with AI assistance.

## Key Features

- **Generate Documentation:** Create optimized markdown documentation and visualize repository structures.
- **Smart Commits:** Get AI-generated commit messages based on semantic analysis of your changes.
- **AI-Powered PRs:** Streamline pull request creation and management with intelligent suggestions.
- **Multi-LLM Support:** Integrate with various LLM providers via LiteLLM.

Explore the documentation sections to learn more:

- [Installation](installation.md)
- [Usage Guide](usage/index.md)
- [Configuration](usage/configuration.md)
- [Development Setup](contributing/index.md)
- [Contributing Guide](contributing/guidelines.md)