"""
This type stub file was generated by pyright.
"""

from typing import Callable

"""Git implementation of _version.py."""
def get_keywords(): # -> dict[str, str]:
    """Get the keywords needed to look up the version information."""
    ...

class VersioneerConfig:
    """Container for Versioneer configuration parameters."""
    ...


def get_config(): # -> VersioneerConfig:
    """Create, populate and return the VersioneerConfig() object."""
    ...

class NotThisMethod(Exception):
    """Exception raised if a method is not valid for the current scenario."""
    ...


LONG_VERSION_PY: dict[str, str] = ...
HANDLERS: dict[str, dict[str, Callable]] = ...
def register_vcs_handler(vcs, method): # -> Callable[..., Any]:
    """Create decorator to mark a method as the handler of a VCS."""
    ...

def run_command(commands, args, cwd=..., verbose=..., hide_stderr=..., env=...): # -> tuple[None, None] | tuple[None, int | Any] | tuple[Any, Literal[0]]:
    """Call the given command(s)."""
    ...

def versions_from_parentdir(parentdir_prefix, root, verbose): # -> dict[str, Any]:
    """Try to determine the version from the parent directory name.

    Source tarballs conventionally unpack into a directory that includes both
    the project name and a version string. We will also support searching up
    two directory levels for an appropriately named parent directory
    """
    ...

@register_vcs_handler("git", "get_keywords")
def git_get_keywords(versionfile_abs): # -> dict[Any, Any]:
    """Extract version information from the given file."""
    ...

@register_vcs_handler("git", "keywords")
def git_versions_from_keywords(keywords, tag_prefix, verbose): # -> dict[str, Any]:
    """Get version information from git keywords."""
    ...

@register_vcs_handler("git", "pieces_from_vcs")
def git_pieces_from_vcs(tag_prefix, root, verbose, runner=...): # -> dict[Any, Any]:
    """Get version from 'git describe' in the root of the source tree.

    This only gets called if the git-archive 'subst' keywords were *not*
    expanded, and _version.py hasn't already been rewritten with a short
    version string, meaning we're inside a checked out source tree.
    """
    ...

def plus_or_dot(pieces) -> str:
    """Return a + if we don't already have one, else return a ."""
    ...

def render_pep440(pieces): # -> str:
    """Build up version string, with post-release "local version identifier".

    Our goal: TAG[+DISTANCE.gHEX[.dirty]] . Note that if you
    get a tagged build and then dirty it, you'll get TAG+0.gHEX.dirty

    Exceptions:
    1: no tags. git_describe was just HEX. 0+untagged.DISTANCE.gHEX[.dirty]
    """
    ...

def render_pep440_branch(pieces): # -> str:
    """TAG[[.dev0]+DISTANCE.gHEX[.dirty]] .

    The ".dev0" means not master branch. Note that .dev0 sorts backwards
    (a feature branch will appear "older" than the master branch).

    Exceptions:
    1: no tags. 0[.dev0]+untagged.DISTANCE.gHEX[.dirty]
    """
    ...

def pep440_split_post(ver): # -> tuple[str, int | None]:
    """Split pep440 version string at the post-release segment.

    Returns the release segments before the post-release and the
    post-release version number (or -1 if no post-release segment is present).
    """
    ...

def render_pep440_pre(pieces): # -> str:
    """TAG[.postN.devDISTANCE] -- No -dirty.

    Exceptions:
    1: no tags. 0.post0.devDISTANCE
    """
    ...

def render_pep440_post(pieces): # -> str:
    """TAG[.postDISTANCE[.dev0]+gHEX] .

    The ".dev0" means dirty. Note that .dev0 sorts backwards
    (a dirty tree will appear "older" than the corresponding clean one),
    but you shouldn't be releasing software with -dirty anyways.

    Exceptions:
    1: no tags. 0.postDISTANCE[.dev0]
    """
    ...

def render_pep440_post_branch(pieces): # -> str:
    """TAG[.postDISTANCE[.dev0]+gHEX[.dirty]] .

    The ".dev0" means not master branch.

    Exceptions:
    1: no tags. 0.postDISTANCE[.dev0]+gHEX[.dirty]
    """
    ...

def render_pep440_old(pieces): # -> str:
    """TAG[.postDISTANCE[.dev0]] .

    The ".dev0" means dirty.

    Exceptions:
    1: no tags. 0.postDISTANCE[.dev0]
    """
    ...

def render_git_describe(pieces):
    """TAG[-DISTANCE-gHEX][-dirty].

    Like 'git describe --tags --dirty --always'.

    Exceptions:
    1: no tags. HEX[-dirty]  (note: no 'g' prefix)
    """
    ...

def render_git_describe_long(pieces):
    """TAG-DISTANCE-gHEX[-dirty].

    Like 'git describe --tags --dirty --always -long'.
    The distance/hash is unconditional.

    Exceptions:
    1: no tags. HEX[-dirty]  (note: no 'g' prefix)
    """
    ...

def render(pieces, style): # -> dict[str, Any]:
    """Render the given version pieces into the requested style."""
    ...

def get_versions(): # -> dict[str, Any]:
    """Get version information or return default if unable to do so."""
    ...

