"""
This type stub file was generated by pyright.
"""

import numba
import numpy as np
from typing import TYPE_CHECKING
from pandas._typing import npt

"""
Numba 1D mean kernels that can be shared by
* Dataframe / Series
* groupby
* rolling / expanding

Mirrors pandas/_libs/window/aggregation.pyx
"""
if TYPE_CHECKING:
    ...
@numba.jit(nopython=True, nogil=True, parallel=False)
def add_mean(val: float, nobs: int, sum_x: float, neg_ct: int, compensation: float, num_consecutive_same_value: int, prev_value: float) -> tuple[int, float, int, float, int, float]:
    ...

@numba.jit(nopython=True, nogil=True, parallel=False)
def remove_mean(val: float, nobs: int, sum_x: float, neg_ct: int, compensation: float) -> tuple[int, float, int, float]:
    ...

@numba.jit(nopython=True, nogil=True, parallel=False)
def sliding_mean(values: np.ndarray, result_dtype: np.dtype, start: np.ndarray, end: np.ndarray, min_periods: int) -> tuple[np.ndarray, list[int]]:
    ...

@numba.jit(nopython=True, nogil=True, parallel=False)
def grouped_mean(values: np.ndarray, result_dtype: np.dtype, labels: npt.NDArray[np.intp], ngroups: int, min_periods: int) -> tuple[np.ndarray, list[int]]:
    ...

