"""
This type stub file was generated by pyright.
"""

from typing import TYPE_CHECKING
from pandas.util._decorators import doc
from pandas.core.shared_docs import _shared_docs
from pandas.io.excel._base import BaseExcelReader
from pyxlsb import Workbook
from pandas._typing import FilePath, ReadBuffer, Scalar, StorageOptions

if TYPE_CHECKING:
    ...
class PyxlsbReader(BaseExcelReader["Workbook"]):
    @doc(storage_options=_shared_docs["storage_options"])
    def __init__(self, filepath_or_buffer: FilePath | ReadBuffer[bytes], storage_options: StorageOptions | None = ..., engine_kwargs: dict | None = ...) -> None:
        """
        Reader using pyxlsb engine.

        Parameters
        ----------
        filepath_or_buffer : str, path object, or Workbook
            Object to be parsed.
        {storage_options}
        engine_kwargs : dict, optional
            Arbitrary keyword arguments passed to excel engine.
        """
        ...
    
    def load_workbook(self, filepath_or_buffer: FilePath | ReadBuffer[bytes], engine_kwargs) -> Workbook:
        ...
    
    @property
    def sheet_names(self) -> list[str]:
        ...
    
    def get_sheet_by_name(self, name: str):
        ...
    
    def get_sheet_by_index(self, index: int):
        ...
    
    def get_sheet_data(self, sheet, file_rows_needed: int | None = ...) -> list[list[Scalar]]:
        ...
    


