"""
This type stub file was generated by pyright.
"""

from typing import TYPE_CHECKING
from pandas._libs import lib
from collections.abc import Sequence
from pathlib import Path
from pandas._typing import DtypeBackend
from pandas import DataFrame

if TYPE_CHECKING:
    ...
def read_spss(path: str | Path, usecols: Sequence[str] | None = ..., convert_categoricals: bool = ..., dtype_backend: DtypeBackend | lib.NoDefault = ...) -> DataFrame:
    """
    Load an SPSS file from the file path, returning a DataFrame.

    Parameters
    ----------
    path : str or Path
        File path.
    usecols : list-like, optional
        Return a subset of the columns. If None, return all columns.
    convert_categoricals : bool, default is True
        Convert categorical columns into pd.Categorical.
    dtype_backend : {'numpy_nullable', 'pyarrow'}, default 'numpy_nullable'
        Back-end data type applied to the resultant :class:`DataFrame`
        (still experimental). Behaviour is as follows:

        * ``"numpy_nullable"``: returns nullable-dtype-backed :class:`DataFrame`
          (default).
        * ``"pyarrow"``: returns pyarrow-backed nullable :class:`ArrowDtype`
          DataFrame.

        .. versionadded:: 2.0

    Returns
    -------
    DataFrame

    Examples
    --------
    >>> df = pd.read_spss("spss_data.sav")  # doctest: +SKIP
    """
    ...

