"""
This type stub file was generated by pyright.
"""

from typing import Dict

class IndexParam:
    def __init__(self, field_name: str, index_type: str, index_name: str, **kwargs) -> None:
        """
        Examples:

            >>> IndexParam(
            >>>     field_name="embeddings",
            >>>     index_type="HNSW",
            >>>     index_name="hnsw_index",
            >>>     metric_type="COSINE",
            >>>     M=64,
            >>>     efConstruction=100,
            >>> )
        """
        ...
    
    @property
    def field_name(self): # -> str:
        ...
    
    @property
    def index_name(self): # -> str:
        ...
    
    @property
    def index_type(self): # -> str:
        ...
    
    def get_index_configs(self) -> Dict:
        """return index_type and index configs in a dict

        Examples:

            {
                "index_type": "HNSW",
                "metrics_type": "COSINE",
                "M": 64,
                "efConstruction": 100,
            }
        """
        ...
    
    def to_dict(self) -> Dict:
        """All params"""
        ...
    
    def __str__(self) -> str:
        ...
    
    __repr__ = ...
    def __eq__(self, other: None) -> bool:
        ...
    


class IndexParams(list):
    """List of indexs of a collection"""
    def __init__(self, *args, **kwargs) -> None:
        ...
    
    def add_index(self, field_name: str, index_type: str = ..., index_name: str = ..., **kwargs): # -> None:
        ...
    


